# coding: utf-8

# 2016-11-19 programmeerimisvõistlus
# Ülesanne: ALGARVU-SCRABBLE (edasijõudnute variant)
# Autor: Ahto Truu

# Algarvulisuse kontrolli kiirendamiseks arvutame väiksemad
# algarvud ette valmis ja suuremaid kontrollides vaatame
# ainult algarvulisi tegureid

import bisect # kahendotsing

# leiab kivijada a summa
def summa(a):
	n = 0
	for x in a:
		if x == '0':
			n = n + 10
		else:
			n = n + int(x)
	return n

# arvutab valmis algarvude tabeli
algarvud = []
def leia_algarvud(n):
	algarvud.append(2)
	for k in range(3, n, 2):
		for i in algarvud:
			if k % i == 0:
				break;
			if k < i * i:
				algarvud.append(k)
				break

# kontrollib, kas kivijada a on algarv
def algarv(a):
	# kõigepealt leiame jada esitatava arvu väärtuse
	n = int(a)
	# nüüd kontrollime, kas see on algarv
	i = bisect.bisect_left(algarvud, n)
	if i < len(algarvud):
		# piisavalt väikese arvu korral kontrollime, kas ta on tabelis
		return algarvud[i] == n
	# suure arvu korral proovime jagada kõigi algarvudega
	# see töötab õigesti ainult piisavalt suure tabeli korral
	for i in algarvud:
		if n % i == 0:
			return False
		if n < i * i:
			return True

# globaalsed muutujad parima leitud lahenduse hoidmiseks
# parim_plaan on käigujada, kus iga käik on paar
# (kivi, 0/1 == vasakule/paremale)
parim_summa = -100
parim_plaan = []

# proovib panna kivid lauale jadas p näidatud järjekorras
# iga kivi võib panna seisule juurde kas vasakule või paremale
# a on jooksev seis laual, b senine käigujada,
# s seni kogunenud skoor, t trahviks minevad kivid
def otsi(p, a, b, s, t):
	global parim_summa, parim_plaan
	if len(a) == len(p):
		# kõik kivid on pandud, teeme lõpuarvestuse
		s = s - summa(t)
		if parim_summa < s:
			parim_plaan = b[ : len(b) - len(t)]
			parim_summa = s
	else:
		# järjekorras järgmine kivi
		x = p[len(a)]
		# proovime panna järgmise kivi vasakule
		kaik(p, x + a, b + [(x, 0)], s, t + x)
		# proovime panna järgmise kivi paremale
		kaik(p, a + x, b + [(x, 1)], s, t + x)

# arvutab viimase tehtud käigu mõju skoorile ja trahvile
def kaik(p, a, b, s, t):
	if algarv(a):
		s = s + summa(a)
		t = ''
	if algarv(a[::-1]):
		s = s + summa(a)
		t = ''
	# otsime järgmist käiku
	otsi(p, a, b, s, t)

# genereerib kivide jada a kõik järjekorrad (permutatsioonid)
# a on olemasolevate kivide hulk, v nende olekud (laual/käes)
# p seni kogunenud osaline ümberjärjestus
def perm(a, v, p):
	if len(p) == len(a):
		# ümberjärjestus valmis
		otsi(p, '', [], 0, '')
	else:
		# proovime järgmiseks kiviks kõiki veel käes olevaid
		for (i, x) in enumerate(a):
			if v[i]:
				v[i] = False
				perm(a, v, p + x)
				v[i] = True

#
# põhiprogrammi algus
#

sis = open('algesis.txt', 'rt')
val = open('algeval.txt', 'wt')

n = int(sis.readline().strip())
a = ''.join(sis.readline().strip().split())
v = [True] * len(a)

leia_algarvud(min(10 ** n, 1000000))
assert(algarvud[-1] * algarvud[-1] > 10 ** n)

perm(a, v, '')

val.write('{0} {1}\n'.format(len(parim_plaan), parim_summa))
s = 0
a = ''
for (x, k) in parim_plaan:
	if k == 0:
		a = x + a
	if k == 1:
		a = a + x
	if algarv(a):
		s = s + summa(a)
	if algarv(a[::-1]):
		s = s + summa(a)
	val.write('{0} {1}\n'.format(a, s))
val.write('{0}\n'.format(parim_summa - s))
