# coding: utf-8

# 2016-11-19 programmeerimisvõistlus
# Ülesanne: ALGARVU-SCRABBLE (edasijõudnute variant)
# Autor: Ahto Truu

# Alustab lahendamist lõpust, siis saab iga pooliku seisu kohta
# meeles pidada selle parima skoori

import bisect # kahendotsing

# leiab kivijada a summa
def summa(a):
	n = 0
	for x in a:
		if x == '0':
			n = n + 10
		else:
			n = n + int(x)
	return n

# arvutab valmis algarvude tabeli
algarvud = []
def leia_algarvud(n):
	algarvud.append(2)
	for k in range(3, n, 2):
		for i in algarvud:
			if k % i == 0:
				break;
			if k < i * i:
				algarvud.append(k)
				break

# kontrollib, kas kivijada a on algarv
arvud = {}
def algarv(a):
	# kõigepealt leiame jada esitatava arvu väärtuse
	n = int(a)
	# nüüd kontrollime, kas see on algarv
	i = bisect.bisect_left(algarvud, n)
	if i < len(algarvud):
		# piisavalt väikese arvu korral kontrollime, kas ta on tabelis
		return algarvud[i] == n
	# suure arvu korral vaatame, kas me oleme seda juba uurinud
	if not n in arvud:
		# mälus tulemust ei ole, arvutame; proovime jagada kõigi algarvudega
		# see töötab õigesti ainult piisavalt suure tabeli korral
		for i in algarvud:
			if n % i == 0:
				arvud[n] = False
				break
			if n < i * i:
				arvud[n] = True
				break
	return arvud[n]

# leiab parima hinde, millega saab jõuda seisu a
# hinne on kaheosaline: skoor lauale pandud kivide
# ja trahv kätte jäänud kivide eest
# iga juba uuritud seisu hinded peame meeles, samuti
# sellesse seisu jõudmiseks tehtud viimase käigu
hinded = {}
def hinda(a):
	if len(a) == 0:
		return (0, 0, 0)
	if not a in hinded:
		# mälus tulemust ei ole, arvutame
		(s1, t1, k1) = hinda(a[1:])
		(s2, t2, k2) = hinda(a[:-1])
		t1 = t1 + summa(a[0])
		t2 = t2 + summa(a[-1])
		s = 0
		if algarv(a):
			s = s + summa(a)
			t1, t2 = 0, 0
		if algarv(a[::-1]):
			s = s + summa(a)
			t1, t2 = 0, 0
		if s1 - t1 > s2 - t2:
			hinded[a] = (s1 + s, t1, 0)
		else:
			hinded[a] = (s2 + s, t2, 1)
	return hinded[a]

# globaalsed muutujad parima leitud lahenduse hoidmiseks
# parim_seis on lõppseis, millega parima summa saime
parim_summa = -100
parim_seis = ''

# genereerib kivide jada a kõik permutatsioonid
def perm(a):
	global parim_summa, parim_seis
	a = list(a)
	a.sort()
	a = ''.join(a)
	while True:
		# ümberjärjestus valmis, hindame selle
		(s, t, k) = hinda(a)
		if parim_summa < s - t:
			parim_summa = s - t
			parim_seis = a
		# leiame järgmise
		# vt https://en.wikipedia.org/wiki/Permutation#Generation_in_lexicographic_order
		k = n - 2
		while k >= 0 and a[k] >= a[k + 1]:
			k = k - 1
		if k < 0:
			# oli viimane permutatsiooni
			break
		i = n - 1
		while a[k] >= a[i]:
			i = i - 1
		a = a[0:k] + a[i] + (a[i+1:n])[::-1] + a[k] + (a[k+1:i])[::-1]

# taastab antud seisuni viiva käigujada
# iga käik on paar (kivi, 0/1 == vasakule/paremale)
# x==True näitab, et oleme selles osas, kus käike tehakse
# mitte ei koguta trahve kätte jäänud kivide eest
def sammud(a, x):
	if len(a) == 0:
		return []
	else:
		x = x or algarv(a) or algarv(a[::-1])
		(s, t, k) = hinded[a]
		if k == 0:
			if x:
				return sammud(a[1:], x) + [(a[0], 0)]
			else:
				return sammud(a[1:], x)
		if k == 1:
			if x:
				return sammud(a[:-1], x) + [(a[-1], 1)]
			else:
				return sammud(a[:-1], x)

#
# põhiprogrammi algus
#

sis = open('algesis.txt', 'rt')
val = open('algeval.txt', 'wt')

n = int(sis.readline().strip())
a = ''.join(sis.readline().strip().split())

leia_algarvud(min(10 ** n, 1000000))
assert(algarvud[-1] * algarvud[-1] > 10 ** n)

perm(a)

parim_plaan = sammud(parim_seis, False)
val.write('{0} {1}\n'.format(len(parim_plaan), parim_summa))
s = 0
a = ''
for (x, k) in parim_plaan:
	if k == 0:
		a = x + a
	if k == 1:
		a = a + x
	if algarv(a):
		s = s + summa(a)
	if algarv(a[::-1]):
		s = s + summa(a)
	val.write('{0} {1}\n'.format(a, s))
val.write('{0}\n'.format(parim_summa - s))
