#include <cstdio>
#include <cstdlib>
#include <cstdarg>
#include <cctype>
#include <cmath>
#include <cstring>

void done(double n, const char *s, ...) {
	fprintf(stdout, "%.7lf\n", n);
	va_list ap;
	va_start(ap, s);
	vfprintf(stderr, s, ap);
	va_end(ap);
	fprintf(stderr, "\n");
	exit(0);
}

bool blank(const char *s) {
	while (isspace(*s)) {
		++s;
	}
	return *s == 0;
}

char s[10000]; int u1, u2;
int n, m0, m1, mc, v1, v2;
int parim_summa;
int summa_lahendus;
int kivid[10];
int maxtrahv = 0;


char manguseis[20];
char uus_kaik[20];

int isprime (int p) {
        int i;
        if ((p == 1) || (p == 0))
                return 0;
        for (i = 2; i <= sqrt(p); i++)
                if (p % i == 0)
                        return 0;
        return 1;
}


int main(int argc, const char *argv[]) {
	if (argc != 4) {
		done(0, "Usage: %s input hint output", argv[0]);
	}

	FILE *in = fopen(argv[1], "rt");
	if (!in) {
		done(0, "Can't open input file %s", argv[1]);
	}
	FILE *hint = fopen(argv[2], "rt");
	if (!hint) {
		done(0, "Can't open hint file %s", argv[2]);
	}
	FILE *out = fopen(argv[3], "rt");
	if (!out) {
		done(0, "Can't open output file %s", argv[3]);
	}

	if (fscanf(in, "%d", &n) != 1) {
		done(0, "Invalid format on line 1 of input file");
	}

	for (int i = 0; i < n; ++i) {
		if (fscanf(in, "%d", &m1) != 1) {
			done(0, "Invalid format on line 2 field %d of input file", 1 + i);
		}
		++kivid[m1];
		maxtrahv += (m1 == 0) ? 10 : m1;
	}

	if (fscanf(hint, "%d %d", &v1, &parim_summa) != 2) {
		done(0, "Invalid format on line 1 of hint file");
	}


	if (fgets(s, sizeof(s), out) != s) {
		done(0, "Unexpected end of output file");
	}


	int kaigud_lahendus;
	if (sscanf(s, "%d %d%n", &kaigud_lahendus, &summa_lahendus, &u1) != 2 || !blank(s + u1)) {
		done(0, "Invalid format on line 1 of output file");
	}

	strcpy(manguseis,"");
	int skoor = 0;

	for (int i = 0; i < kaigud_lahendus; ++i) {
	
		int uus_skoor;
		if (fgets(s, sizeof(s), out) != s) {
			done(0, "Unexpected end of output file");
		}
	
		if (sscanf(s, "%s %d%n", &uus_kaik, &uus_skoor, &u1) != 2) {
			done(0, "Invalid format on line %d of output file", i + 2);
		}

		if (strlen(uus_kaik) != strlen(manguseis) +  1) 
			done(0, "Incorrect move");

		int j;
		int uus_kivi = -1;

		for (j = 0; j < strlen(manguseis) && (uus_kaik[j] == manguseis[j]); j++);
		if (j == strlen(manguseis))
			uus_kivi = uus_kaik[j] - '0';
		for (j=strlen(uus_kaik);j > 0 && uus_kaik[j] == manguseis[j-1];j--);
		if (j == 0)
			uus_kivi = uus_kaik[0] - '0';

		if (uus_kivi == -1)
			done(0,"Incorrect move");

		if (kivid[uus_kivi] < 1) 
			done(0,"Incorrect move");

		kivid[uus_kivi]--;
	

		int vasak = 0;
		int parem = 0;		
		int rs = 0;
		for (int j = 0; j < strlen(uus_kaik); j++) {
			parem = parem * 10  + (uus_kaik[j] - '0');
			vasak = vasak * 10  + (uus_kaik[strlen(uus_kaik) - j  - 1 ] - '0');
			rs += (uus_kaik[j] == '0') ? 10 : (uus_kaik[j] - '0');
			
		}

		if (uus_skoor != skoor + (isprime(vasak) ? rs : 0) + (isprime(parem) ? rs : 0))
			done(0,"Incorrect intermediate score");

		if ((i == kaigud_lahendus - 1) && (skoor == uus_skoor)) 
			done(0,"No prime after last move");

		skoor = uus_skoor;
		strcpy(manguseis, uus_kaik);
	}

	if (fgets(s, sizeof(s), out) != s) {
		done(0, "Unexpected end of output file");
	}
	

	int trahv;	
	if (sscanf(s, "%d%n", &trahv, &u1) != 1) {
		done(0, "Invalid format on line %d of output file", kaigud_lahendus + 2);
	}


	if (skoor + trahv != summa_lahendus) 
		done(0, "Incorrect final score");

	for (int j = 0; j < 10 ; j++) 
		trahv += ((j == 0) ? 10 : j) * kivid[j];

	if (trahv != 0)
		done(0, "Incorrect penalty points");
			
		

	if (fscanf(out, "%10s", s) > 0) {
		done(0, "Extra data at end of output file");
	}

	if (summa_lahendus < parim_summa) 
		done(((double)summa_lahendus + maxtrahv) / (parim_summa + maxtrahv) , "Correct, but non-optimal game");


	done(1, "OK");

}
