﻿using System;
using System.Collections.Generic;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Xml.Schema;
using System.IO;

namespace checker
{
    internal class Program
    {
        private static void Main(string[] args)
        {
            if (args.Length < 3)
            {
                Console.WriteLine("Usage: input, true output, student output");
            }

            try
            {
                String[] outputLines = File.ReadAllLines(args[1]);
                String[] studentLines = File.ReadAllLines(args[2]);

                if (outputLines.Length != studentLines.Length)
                {
                    Console.WriteLine("0");
                    Console.Error.WriteLine("Vale vastus");
                    return;
                }

                if (outputLines[0] == "-1")
                {
                    if (studentLines[0] == "-1")
                    {
                        Console.WriteLine("1");
                        Console.Error.WriteLine("OK");
                        return;
                    }
                    Console.WriteLine("0");
                    Console.Error.WriteLine("Vale vastus");
                    return;
                }
                else
                {
                    bool vastus = false;
                    double ra = double.Parse(outputLines[0], CultureInfo.InvariantCulture);
                    double sa = double.Parse(studentLines[0], CultureInfo.InvariantCulture);
                    double d = Math.Abs(ra - sa);
                    if (d <= 0.0001)
                    {
                        vastus = true;
                    }

                    if (vastus && outputLines.Length > 1)
                    {
                        int rn = Int32.Parse(outputLines[1], CultureInfo.InvariantCulture);
                        int sn = Int32.Parse(studentLines[1], CultureInfo.InvariantCulture);

                        if (rn != sn)
                        {
                            vastus = false;
                        }
                    }
                    if (vastus)
                    {
                        Console.WriteLine("1");
                        Console.Error.WriteLine("OK");
                    }
                    else
                    {
                        Console.WriteLine("0");
                        Console.Error.WriteLine("Vale vastus");
                    }
                }
            }
            catch (Exception ex)
            {
                Console.WriteLine(0);
                Console.Error.WriteLine("Vale vastus");
            }
        }
    }
}