# coding: utf-8

# 2016-11-19 programmeerimisvõistlus
# Ülesanne: SARNASED KOLMNURGAD (põhikooli variant)
# Autor: Ahto Truu

# Ainult täisarvulisel aritmeetikal põhinev (ümardamisteta ja
# ligikaudsete arvudeta) lahendus

import math

# punktide (x1,y1) ja (x2,y2) vahelise kauguse ruut
def kaug(x1, y1, x2, y2):
	return (x2 - x1) * (x2 - x1) + (y2 - y1) * (y2 - y1)

# kontrollib, kas kas kolmnurgad (xa1,ya1)-(xb1,yb1)-(xc1,yc1) ja
# (xa2,ya2)-(xb2,yb2)-(xc2,yc2) on sarnased nii, et vastavuses on
# a1 ja a2, b1 ja b2, c1 ja c2
# kui on, tagastab sarnasusteguri
# kui ei, tagastab -1
def sarn(xa1, ya1, xb1, yb1, xc1, yc1, xa2, ya2, xb2, yb2, xc2, yc2):
	# kauguste endi asemel võime võrrelda ka nende ruutusid
	ab1 = kaug(xa1, ya1, xb1, yb1)
	ab2 = kaug(xa2, ya2, xb2, yb2)
	bc1 = kaug(xb1, yb1, xc1, yc1)
	bc2 = kaug(xb2, yb2, xc2, yc2)
	ca1 = kaug(xc1, yc1, xa1, ya1)
	ca2 = kaug(xc2, yc2, xa2, ya2)
	# tahame kontrollida, kas ab1/ab2 = bc1/bc2 = ca1/ca2
	# jagamise ja reaalarvude vältimiseks kontrollime
	# ab1/ab2 = bc1/bc2 asemel ab1*bc2 = ab2*bc1 ja
	# ab1/ab2 = ca1/ca2 asemel ab1*ca2 = ab2*ca1
	if ab1 * bc2 == ab2 * bc1 and ab1 * ca2 == ab2 * ca1:
		# sarnasusteguri peame lõpuks ikka reaalarvuna arvutama
		# ja siin on vaja ka küljepikkusi endid, mitte nende ruute
		return math.sqrt(ab1) / math.sqrt(ab2)
	else:
		return -1

#
# põhiprogrammi algus
#

sis = open('nurkpsis.txt', 'rt')
val = open('nurkpval.txt', 'wt')

(xa1, ya1, xb1, yb1, xc1, yc1) = map(int, sis.readline().strip().split())
(xa2, ya2, xb2, yb2, xc2, yc2) = map(int, sis.readline().strip().split())

k = -1
# proovime kõiki võimalikke vastavusi esimese ja teise kolmnurga tippude vahel
if k < 0: k = sarn(xa1, ya1, xb1, yb1, xc1, yc1, xa2, ya2, xb2, yb2, xc2, yc2)
if k < 0: k = sarn(xa1, ya1, xb1, yb1, xc1, yc1, xb2, yb2, xc2, yc2, xa2, ya2)
if k < 0: k = sarn(xa1, ya1, xb1, yb1, xc1, yc1, xc2, yc2, xa2, ya2, xb2, yb2)
if k < 0: k = sarn(xa1, ya1, xb1, yb1, xc1, yc1, xc2, yc2, xb2, yb2, xa2, ya2)
if k < 0: k = sarn(xa1, ya1, xb1, yb1, xc1, yc1, xb2, yb2, xa2, ya2, xc2, yc2)
if k < 0: k = sarn(xa1, ya1, xb1, yb1, xc1, yc1, xa2, ya2, xc2, yc2, xb2, yb2)

val.write("{0}\n".format(k))
